﻿using Styx.Common.Helpers;
using Styx.Common;
using Styx.CommonBot.Inventory;
using Styx.CommonBot;
using Styx.Helpers;
using Styx.Pathing;
using Styx.Plugins;
using Styx.WoWInternals.WoWObjects;
using Styx.WoWInternals;
using Styx;
using System.Collections.Generic;
using System.Diagnostics;
using System.Globalization;
using System.IO;
using System.Linq.Expressions;
using System.Linq;
using System.Media;
using System.Net;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading;
using System.Windows.Forms;
using System.Xml.Linq;
using System;


namespace HB.Plugins.NoMoveDetector
{
    class NoMoveDetector : HBPlugin
    {
        #region Overrides of HBPlugin

        public override void Initialize()
        {
            Styx.CommonBot.BotEvents.OnBotStart += _OnBotStart;
            _init();
        }
        public override void Dispose()
        {
            Styx.CommonBot.BotEvents.OnBotStart -= _OnBotStart;
        }
        public override string ButtonText { get { return "---"; } }
        public override bool WantButton { get { return false; } }
        public override void OnButtonPress(){}
        public override void Pulse(){_MainPulseProc();}
        public override string Name { get { return "No Move Detector"; } }
        public override string Author { get { return "cls15"; } }
        public override Version Version { get { return new Version(1, 2, 0); } }

        #endregion

        private Stopwatch LastOK ;
        private WoWPoint LastLoc;
        private int nBotRestart;
        private static Thread RestartThread;

        private static void _RestartThread()
        {
           // TreeRoot.Stop();
           // Thread.Sleep(2000);
           // TreeRoot.Start();
        }

        private void _OnBotStart(EventArgs args)
        {
            Logging.Write(@"[NoMoveDetector] Bot started");
            LastLoc = StyxWoW.Me.Location;
            LastOK.Restart();
            RestartThread = new Thread(new ThreadStart(_RestartThread));
        }

        private void _init()
        {
            Logging.Write(@"[NoMoveDetector] init");
            LastOK = new Stopwatch();
            nBotRestart = 0;
        }

        private void _MainPulseProc()
        {
            // Must we go futher anyway?
            if (!TreeRoot.IsRunning)
            {
                if (LastOK.ElapsedMilliseconds > 1000 * 30)
                {
                    Logging.Write(@"[NoMoveDetector] LastPosition reseted, bot is not running (but pulse is called ???)");
                    LastOK.Restart();
                }
                return;
            } 
            
            WoWPlayer Me = StyxWoW.Me;
            //Cancel timer if move > 10 yards is detected
            if (LastLoc.Distance(Me.Location) > 10f)
            {
                if (LastOK.ElapsedMilliseconds > 1000 * 30)  Logging.Write(@"[NoMoveDetector] Move detected. LastPosition reseted");
                LastOK.Restart();
                LastLoc = Me.Location;
                return;
            }

            // Have we moved whithin last 3 mins
            if (LastOK.ElapsedMilliseconds > 1000*60*3)
            {

                if (Me.HasAura("Resurrection Sickness"))
                {
                    LastOK.Restart();
                    return;
                }

                else
                {
                    Logging.Write(@"[NoMoveDetector] not mooving last {0} min : Restarting bot...",nBotRestart*5);
					SoundPlayer sp = new SoundPlayer();
					sp.SoundLocation = Application.StartupPath + @"\Plugins\AlertMe\Sounds\beep.wav";
					sp.Play();
					LastOK.Restart();
					return;
                    //RestartThread.Start();
                }
                
            }
        }
    }
}
